# DB2

> JDBC DB2 Source Connector

### Description[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#description) <a href="#description" id="description"></a>

Read external data source data through JDBC.

### Key Features[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#key-features) <a href="#key-features" id="key-features"></a>

* [x] &#x20;[batch](https://seatunnel.apache.org/docs/2.3.7/concept/connector-v2-features)
* [ ] &#x20;stream
* [x] &#x20;exactly-once
* [x] &#x20;column projection
* [x] &#x20;parallelism
* [x] &#x20;support user-defined split

> supports query SQL and can achieve projection effect.

### Data Type Mapping[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#data-type-mapping) <a href="#data-type-mapping" id="data-type-mapping"></a>

| DB2 Data Type                                                                                        | Nexus Data Type   |   |
| ---------------------------------------------------------------------------------------------------- | ----------------- | - |
| BOOLEAN                                                                                              | BOOLEAN           |   |
| SMALLINT                                                                                             | SHORT             |   |
| <p>INT<br>INTEGER<br></p>                                                                            | INTEGER           |   |
| BIGINT                                                                                               | LONG              |   |
| <p>DECIMAL<br>DEC<br>NUMERIC<br>NUM</p>                                                              | DECIMAL(38,18)    |   |
| REAL                                                                                                 | FLOAT             |   |
| <p>FLOAT<br>DOUBLE<br>DOUBLE PRECISION<br>DECFLOAT</p>                                               | DOUBLE            |   |
| <p>CHAR<br>VARCHAR<br>LONG VARCHAR<br>CLOB<br>GRAPHIC<br>VARGRAPHIC<br>LONG VARGRAPHIC<br>DBCLOB</p> | STRING            |   |
| BLOB                                                                                                 | BYTES             |   |
| DATE                                                                                                 | DATE              |   |
| TIME                                                                                                 | TIME              |   |
| TIMESTAMP                                                                                            | TIMESTAMP         |   |
| <p>ROWID<br>XML</p>                                                                                  | Not supported yet |   |

### Source Options[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#source-options) <a href="#source-options" id="source-options"></a>

| Name                            | Type       | Required | Default         | Description                                                                                                                                                                                                                                                        |
| ------------------------------- | ---------- | -------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| url                             | String     | Yes      | -               | The URL of the JDBC connection. Refer to a case: jdbc:db2://127.0.0.1:50000/dbname                                                                                                                                                                                 |
| driver                          | String     | Yes      | -               | <p>The jdbc class name used to connect to the remote data source,<br>if you use db2 the value is <code>com.ibm.db2.jdbc.app.DB2Driver</code>.</p>                                                                                                                  |
| user                            | String     | No       | -               | Connection instance user name                                                                                                                                                                                                                                      |
| password                        | String     | No       | -               | Connection instance password                                                                                                                                                                                                                                       |
| query                           | String     | Yes      | -               | Query statement                                                                                                                                                                                                                                                    |
| connection\_check\_timeout\_sec | Int        | No       | 30              | The time in seconds to wait for the database operation used to validate the connection to complete                                                                                                                                                                 |
| partition\_column               | String     | No       | -               | The column name for parallelism's partition, only support numeric type,Only support numeric type primary key, and only can config one column.                                                                                                                      |
| partition\_lower\_bound         | BigDecimal | No       | -               | The partition\_column min value for scan, if not set Nexus will query database get min value.                                                                                                                                                                      |
| partition\_upper\_bound         | BigDecimal | No       | -               | The partition\_column max value for scan, if not set Nexus will query database get max value.                                                                                                                                                                      |
| partition\_num                  | Int        | No       | job parallelism | The number of partition count, only support positive integer. default value is job parallelism                                                                                                                                                                     |
| fetch\_size                     | Int        | No       | 0               | <p>For queries that return a large number of objects,you can configure<br>the row fetch size used in the query toimprove performance by<br>reducing the number database hits required to satisfy the selection criteria.<br>Zero means use jdbc default value.</p> |
| properties                      | Map        | No       | -               | <p>Additional connection configuration parameters,when properties and URL have the same parameters, the priority is determined by the<br>specific implementation of the driver. For example, in MySQL, properties take precedence over the URL.</p>                |
| common-options                  |            | No       | -               | Source plugin common parameters, please refer to [Source Common Options](/data-integration-with-nexus/nexus-elements/connectors/source/source-common-options.md) for details                                                                                       |

#### Tips[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#tips) <a href="#tips" id="tips"></a>

> If partition\_column is not set, it will run in single concurrency, and if partition\_column is set, it will be executed in parallel according to the concurrency of tasks.

### Task Example[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#task-example) <a href="#task-example" id="task-example"></a>

#### Simple:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#simple) <a href="#simple" id="simple"></a>

> This example queries type\_bin 'table' 16 data in your test "database" in single parallel and queries all of its fields. You can also specify which fields to query for final output to the console.

```
# Defining the runtime environment
env {
  parallelism = 2
  job.mode = "BATCH"
}
source{
    Jdbc {
        url = "jdbc:db2://127.0.0.1:50000/dbname"
        driver = "com.ibm.db2.jdbc.app.DB2Driver"
        connection_check_timeout_sec = 100
        user = "root"
        password = "123456"
        query = "select * from table_xxx"
    }
}

transform {
    # If you would like to get more information about how to configure nexus and see full list of transform plugins,
    # please go to transform page
}

sink {
    Console {}
}
```

#### Parallel:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#parallel) <a href="#parallel" id="parallel"></a>

> Read your query table in parallel with the shard field you configured and the shard data You can do this if you want to read the whole table

```
source {
    Jdbc {
        url = "jdbc:db2://127.0.0.1:50000/dbname"
        driver = "com.ibm.db2.jdbc.app.DB2Driver"
        connection_check_timeout_sec = 100
        user = "root"
        password = "123456"
        # Define query logic as required
        query = "select * from type_bin"
        # Parallel sharding reads fields
        partition_column = "id"
        # Number of fragments
        partition_num = 10
    }
}
```

#### Parallel Boundary:[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/DB2#parallel-boundary) <a href="#parallel-boundary" id="parallel-boundary"></a>

> It is more efficient to specify the data within the upper and lower bounds of the query It is more efficient to read your data source according to the upper and lower boundaries you configured

```
source {
    Jdbc {
        url = "jdbc:db2://127.0.0.1:50000/dbname"
        driver = "com.ibm.db2.jdbc.app.DB2Driver"
        connection_check_timeout_sec = 100
        user = "root"
        password = "123456"
        # Define query logic as required
        query = "select * from type_bin"
        partition_column = "id"
        # Read start boundary
        partition_lower_bound = 1
        # Read end boundary
        partition_upper_bound = 500
        partition_num = 10
    }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.selfuel.digital/data-integration-with-nexus/nexus-elements/connectors/source/db2.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
